/* mktime - Programm zur Berechnung der Sekundenanzahl seit Anfang 1970
 *
 *          (c) 1996, 1997 Burghard B. Britzke & Gerald Erdmann
 *
 *          Zu Uebersetzen durch "cc -s -O2 mktime.c -o mktime"
 */

#include <time.h>
#include <stdio.h>
#include <stdlib.h>

static int daymonth[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

void main (int argc, char **argv)
{
    struct tm  *lt;
    time_t      curtime;
    int         i, dst;

    if (argc != 7) {
        printf ("USAGE: %s Jahr Monat Tag Stunde Minute Sekunde\n", argv[0]);
        exit (1);
    }

    curtime = time (NULL); lt = localtime (&curtime);
dst = lt->tm_isdst;

    if ((argv[1][0] == '+' || argv[1][0] == '-') && argv[1][1] != '\0') {
        lt->tm_year += atoi (argv[1]);
 curtime = mktime (lt);
    }
    else if (argv[1][0] != '*') {
        lt->tm_year = atoi (argv[1]) - 1900; curtime = mktime (lt);
    } 
    if (argv[2][0] == '+' && argv[2][1] != '\0') {
        for (i = 0; i < atol (argv[2]); i++, lt = localtime (&curtime))
            curtime += 86400 * daymonth[lt->tm_mon];
    }
    else if (argv[2][0] == '-' && argv[2][1] != '\0') {
        for (i = atol (argv[2]); i < 0; i++, lt = localtime (&curtime))
            curtime -= 86400 * daymonth[(lt->tm_mon - 1) % 12];
    }
    else if (argv[2][0] != '*') {
        lt->tm_mon = atoi (argv[2]) - 1; curtime = mktime (lt);
    }
    if ((argv[3][0] == '+' || argv[3][0] == '-') && argv[3][1] != '\0') {
        curtime += 86400 * atol (argv[3]);
lt = localtime (&curtime);
    }
    else if (argv[3][0] != '*') {
        lt->tm_mday = atoi (argv[3]); curtime = mktime (lt);
    }
    if ((argv[4][0] == '+' || argv[4][0] == '-') && argv[4][1] != '\0') {
        curtime += 3600 * atol (argv[4]); lt = localtime (&curtime);
    }
    else if (argv[4][0] != '*') {
        lt->tm_hour = atoi (argv[4]); curtime = mktime (lt);
    }
    if ((argv[5][0] == '+' || argv[5][0] == '-') && argv[5][1] != '\0') {
        curtime += 60 * atol (argv[5]); lt = localtime (&curtime);
    }
    else if (argv[5][0] != '*') {
        lt->tm_min = atoi (argv[5]); curtime = mktime (lt);
    }
    if ((argv[6][0] == '+' || argv[6][0] == '-') && argv[6][1] != '\0') {
        curtime += atol (argv[6]);
lt = localtime (&curtime);
    }
    else if (argv[6][0] != '*') {
        lt->tm_sec = atoi (argv[6]); curtime = mktime (lt);
    }
    if (localtime (&curtime)->tm_isdst != dst)
        curtime += 3600 * (dst - localtime (&curtime)->tm_isdst);

    printf ("%lu\n", curtime);
    exit (0);
}
